"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var _bytes = _interopRequireDefault(require("bytes"));

var _readFileContent = _interopRequireDefault(require("./utils/readFileContent"));

var _generateId = _interopRequireDefault(require("./utils/generateId"));

var Files =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(Files, _React$Component);

  function Files() {
    var _this;

    (0, _classCallCheck2.default)(this, Files);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(Files).call(this));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "input", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "browseFilesPassedParams", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "processSelectedFiles",
    /*#__PURE__*/
    function () {
      var _ref = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(eventFiles) {
        var _this$props, convertToBase64, onSuccess, onError, _assertThisInitialize, browseFilesPassedParams, callbacks, files, errors, i, file;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(eventFiles.length === 0)) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return");

              case 2:
                _this$props = _this.props, convertToBase64 = _this$props.convertToBase64, onSuccess = _this$props.onSuccess, onError = _this$props.onError;
                _assertThisInitialize = (0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), browseFilesPassedParams = _assertThisInitialize.browseFilesPassedParams;
                callbacks = {
                  onSuccess: onSuccess,
                  onError: onError
                };

                if (browseFilesPassedParams && browseFilesPassedParams.onSuccess) {
                  callbacks.onSuccess = browseFilesPassedParams.onSuccess;
                }

                if (browseFilesPassedParams && browseFilesPassedParams.onError) {
                  callbacks.onError = browseFilesPassedParams.onError;
                }

                files = (0, _toConsumableArray2.default)(eventFiles).map(function (file) {
                  return {
                    name: file.name,
                    type: file.type,
                    size: file.size,
                    src: {
                      file: file,
                      base64: null
                    }
                  };
                });
                errors = _this.validateFiles(files);

                if (!errors.length) {
                  _context.next = 13;
                  break;
                }

                callbacks.onError && callbacks.onError(errors, files);
                _context.next = 24;
                break;

              case 13:
                if (!convertToBase64) {
                  _context.next = 23;
                  break;
                }

                i = 0;

              case 15:
                if (!(i < files.length)) {
                  _context.next = 23;
                  break;
                }

                file = files[i].src.file;
                _context.next = 19;
                return (0, _readFileContent.default)(file);

              case 19:
                files[i].src.base64 = _context.sent;

              case 20:
                i++;
                _context.next = 15;
                break;

              case 23:
                callbacks.onSuccess && callbacks.onSuccess(files);

              case 24:
                // Reset the browseFiles arguments.
                _this.input.value = "";
                _this.browseFilesPassedParams = null;

              case 26:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
    _this.input = null;
    _this.browseFilesPassedParams = null;
    return _this;
  }

  (0, _createClass2.default)(Files, [{
    key: "validateFiles",
    value: function validateFiles(files) {
      var _this$props2 = this.props,
          multiple = _this$props2.multiple,
          multipleMaxSize = _this$props2.multipleMaxSize,
          multipleMaxCount = _this$props2.multipleMaxCount,
          accept = _this$props2.accept,
          maxSize = _this$props2.maxSize;

      if (files.length === 0) {
        return [];
      }

      var errors = [];
      var multipleFileSize = 0;

      if (!multiple && files.length > 1) {
        errors.push({
          id: (0, _generateId.default)(),
          type: "multipleNotAllowed"
        });
        return errors;
      }

      for (var index = 0; index < files.length; index++) {
        var file = files[index];

        if (Array.isArray(accept) && accept.length && accept.indexOf(file.type) === -1) {
          errors.push({
            id: (0, _generateId.default)(),
            index: index,
            file: file,
            type: "unsupportedFileType"
          });
        } else if (maxSize) {
          if (file.size > (0, _bytes.default)(maxSize)) {
            errors.push({
              id: (0, _generateId.default)(),
              index: index,
              file: file,
              type: "maxSizeExceeded"
            });
          }
        }

        if (multiple) {
          multipleFileSize += file.size;
        }
      }

      if (multiple) {
        if (multipleMaxSize && multipleFileSize > (0, _bytes.default)(multipleMaxSize)) {
          errors.push({
            id: (0, _generateId.default)(),
            type: "multipleMaxSizeExceeded",
            multipleFileSize: multipleFileSize,
            multipleMaxSize: (0, _bytes.default)(multipleMaxSize)
          });
        }

        if (multipleMaxCount && files.length > multipleMaxCount) {
          errors.push({
            id: (0, _generateId.default)(),
            type: "multipleMaxCountExceeded",
            multipleCount: files.length,
            multipleMaxCount: multipleMaxCount
          });
        }
      }

      return errors;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          multiple = _this$props3.multiple,
          accept = _this$props3.accept;
      return React.createElement("div", null, this.props.children({
        browseFiles: function browseFiles(params) {
          _this2.browseFilesPassedParams = params; // Opens the file browser.

          _this2.input && _this2.input.click();
        },
        getDropZoneProps: function getDropZoneProps(props) {
          return (0, _objectSpread2.default)({}, props, {
            onDragOver: function onDragOver(e) {
              e.preventDefault();
              typeof props.onDragOver === "function" && props.onDragOver();
            },
            onDrop: function () {
              var _onDrop = (0, _asyncToGenerator2.default)(
              /*#__PURE__*/
              _regenerator.default.mark(function _callee2(e) {
                return _regenerator.default.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        e.preventDefault();
                        _context2.next = 3;
                        return _this2.processSelectedFiles(e.dataTransfer.files);

                      case 3:
                        typeof props.onDrop === "function" && props.onDrop();

                      case 4:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2, this);
              }));

              function onDrop(_x2) {
                return _onDrop.apply(this, arguments);
              }

              return onDrop;
            }()
          });
        }
      }), React.createElement("input", {
        ref: function ref(_ref2) {
          if (_ref2) {
            _this2.input = _ref2;
          }
        },
        accept: accept,
        style: {
          display: "none"
        },
        type: "file",
        multiple: multiple,
        onChange: function onChange(e) {
          return _this2.processSelectedFiles(e.target.files);
        }
      }));
    }
  }]);
  return Files;
}(React.Component);

(0, _defineProperty2.default)(Files, "defaultProps", {
  accept: [],
  multiple: false,
  maxSize: "2mb",
  multipleMaxSize: "10mb",
  multipleMaxCount: null,
  convertToBase64: false
});
var _default = Files;
exports.default = _default;
//# sourceMappingURL=Files.js.map